commit 5d62d86d958a217cdb4155a557aeda1d0e644aba
Author: Richard Biener <rguenther@suse.de>
Date:   Fri Nov 11 14:28:52 2022 +0100

    tree-optimization/107554 - fix ICE in stlen optimization
    
    The following fixes a wrongly typed variable causing an ICE.
    
            PR tree-optimization/107554
            * tree-ssa-strlen.c (strlen_pass::count_nonzero_bytes):
            Use unsigned HOST_WIDE_INT type for the strlen.
    
            * gcc.dg/pr107554.c: New testcase.
    
    Co-Authored-By: Nikita Voronov <nik_1357@mail.ru>
    (cherry picked from commit 81de4037454275f8ed6d858fbc129e832c6147ef)

diff --git a/gcc/testsuite/gcc.dg/pr107554.c b/gcc/testsuite/gcc.dg/pr107554.c
new file mode 100644
index 00000000000..8bbe6b07ae9
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/pr107554.c
@@ -0,0 +1,12 @@
+/* { dg-do compile } */
+/* { dg-options "-O -foptimize-strlen" } */
+
+#define ELEMS 0x40000000
+
+int a[ELEMS];
+int b[ELEMS];
+
+int main()
+{
+  __builtin_memcpy(a, b, ELEMS*sizeof(int));
+}
diff --git a/gcc/tree-ssa-strlen.c b/gcc/tree-ssa-strlen.c
index b0874da5d1e..cc744adb3a5 100644
--- a/gcc/tree-ssa-strlen.c
+++ b/gcc/tree-ssa-strlen.c
@@ -4783,7 +4783,7 @@ count_nonzero_bytes (tree exp, unsigned HOST_WIDE_INT offset,
 
   /* Compute the number of leading nonzero bytes in the representation
      and update the minimum and maximum.  */
-  unsigned n = prep ? strnlen (prep, nbytes) : nbytes;
+  unsigned HOST_WIDE_INT n = prep ? strnlen (prep, nbytes) : nbytes;
 
   if (n < lenrange[0])
     lenrange[0] = n;

